// VCSampDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VCSamp.h"
#include "VCSampDlg.h"
#include "ACCES32.H"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define MAXNUMCONFIG 256

/////////////////////////////////////////////////////////////////////////////
// CVCSampDlg dialog

CVCSampDlg::CVCSampDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVCSampDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVCSampDlg)
	m_Address = _T("0000");
	m_Status = _T("");
	m_ValueRead = _T("FF");
	m_ValueWrite = _T("FF");
	m_AddressIndex = -1;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CVCSampDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVCSampDlg)
	DDX_Control(pDX, IDC_AddressList, m_AddressListCtrl);
	DDX_Text(pDX, IDC_AddressEdit, m_Address);
	DDX_Text(pDX, IDC_Status, m_Status);
	DDX_Text(pDX, IDC_ValueReadEdit, m_ValueRead);
	DDX_Text(pDX, IDC_ValueWriteEdit, m_ValueWrite);
	DDX_CBIndex(pDX, IDC_AddressList, m_AddressIndex);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CVCSampDlg, CDialog)
	//{{AFX_MSG_MAP(CVCSampDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_WriteByteButton, OnWriteByteButton)
	ON_BN_CLICKED(IDC_WriteWordButton, OnWriteWordButton)
	ON_BN_CLICKED(IDC_ReadByteButton, OnReadByteButton)
	ON_BN_CLICKED(IDC_ReadWordButton, OnReadWordButton)
	ON_BN_CLICKED(IDC_ExitButton, OnExitButton)
	ON_CBN_SELCHANGE(IDC_AddressList, OnAddressListComboChange)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVCSampDlg message handlers

BOOL CVCSampDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
   int num, i, temp;
   CString CompanyKey, CompanyName, DeviceIDStr, CardName, AddStr;
   char Info[255];
   char TempStr[255];
   TPCI_COMMON_CONFIG buf[MAXNUMCONFIG];
   unsigned long DataType, DataSize;
   int BaseIndexOffset = 0;
   HKEY hKey;

   CompanyName = CString(' ', 255);
   DataSize = CompanyName.GetLength();
   RegOpenKeyEx(HKEY_LOCAL_MACHINE, "Software\\PCIFIND", 0, KEY_READ, &hKey);
   RegQueryValueEx(hKey, "Company", 0, &DataType, (PUCHAR)CompanyName.GetBuffer(255) , &DataSize);
   CompanyName.ReleaseBuffer();
   RegCloseKey(hKey);

   CompanyKey.Format("Software\\%s\\Cardlist", CompanyName);
      
   if (InPortB(0x61) == 0xAA55) {
      MessageBox("ACCESNT.SYS not detected. Please copy ACCESNT.SYS into [NT]/system32/drivers and re-run this sample.", "Warning", MB_OK);
   }

   num = 0;
   RegOpenKeyEx(HKEY_LOCAL_MACHINE, "Software\\PCIFIND\\NTioPCI\\Parameters", 0, 1, &hKey);
   DataSize = sizeof(num);
   if (RegQueryValueEx(hKey, "NumDevices", 0, &DataType, (PUCHAR)&num, &DataSize) != ERROR_SUCCESS)
      num = 0;
   if (num > 0) {
      DataSize = num * sizeof(TPCI_COMMON_CONFIG);
      RegQueryValueEx(hKey, "PCICommonConfig", 0, &DataType, (PUCHAR)buf, &DataSize);
   }
   RegCloseKey (hKey);

   for (i = 0; i < num; i++) {
      if (buf[i].VendorID == 0x494F) {
         try {
            RegOpenKeyEx(HKEY_LOCAL_MACHINE, CompanyKey, 0, 1, &hKey);  
            DataSize = sizeof(Info);
            DeviceIDStr.Format("%4X$", buf[i].DeviceID);
            RegQueryValueEx(hKey, DeviceIDStr, 0, &DataType, (PUCHAR)Info, &DataSize);
            if (strstr(Info, "COM2") != NULL)
               BaseIndexOffset = 2;
            else 
               BaseIndexOffset = 0;
            
            DeviceIDStr.Remove('$');
            CardName = CString(' ', 255);
            DataSize = CardName.GetLength();
            RegQueryValueEx(hKey, DeviceIDStr, 0, &DataType, (PUCHAR)CardName.GetBuffer(255), &DataSize);
            CardName.ReleaseBuffer();

            buf[i].BaseAddresses[2] &= 0xFFFE;
            buf[i].BaseAddresses[3] &= 0xFFFE;
            buf[i].BaseAddresses[4] &= 0xFFFE;
            buf[i].BaseAddresses[5] &= 0xFFFE;

            if (buf[i].BaseAddresses[2 + BaseIndexOffset] > 0) {  // if the card has any base addresses
               sprintf(TempStr, "%s: %4X", CardName, buf[i].BaseAddresses[2 + BaseIndexOffset]);
               temp = m_AddressListCtrl.AddString(TempStr);
            }
            if (buf[i].BaseAddresses[3 + BaseIndexOffset] > 0) {
               AddStr.Format("%s: %4X", CardName, buf[i].BaseAddresses[3 + BaseIndexOffset]);
               m_AddressListCtrl.AddString(AddStr);
            }
            if (BaseIndexOffset == 0) {
               if (buf[i].BaseAddresses[4] > 0) {
                  AddStr.Format("%s: %4X", CardName, buf[i].BaseAddresses[4]);
                  m_AddressListCtrl.AddString(AddStr);
               }
               if (buf[i].BaseAddresses[5] > 0) {
                  AddStr.Format("%s: %4X", CardName, buf[i].BaseAddresses[5]);
                  m_AddressListCtrl.AddString(AddStr);
               }
            }  //  end if BaseIndexOffset
         }  //  end try
         catch ( ... ) {
         }  //  end try/catch
         RegCloseKey(hKey);
      }  //  end if ACCES Card
   }  //  end for i

   if (num > 0) {
      m_AddressListCtrl.SetCurSel(0);
      UpdateData(true);
      m_AddressListCtrl.GetLBText(0, AddStr);
      m_Address = AddStr.Right(4);
   }
   UpdateData(false);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVCSampDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVCSampDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CVCSampDlg::OnWriteByteButton() 
{
	UpdateData(true);
	unsigned long Address;
	unsigned char Value;
	sscanf(m_Address, "%lx", &Address);
	sscanf(m_ValueWrite, "%x", &Value);

   Value = Value & 0xFF;    //Make sure Value is 8 Bit (Byte)
	OutPortB(Address, Value);

	m_Status = " Write was successful";
	UpdateData(false);
}  //  end OnWriteByteButton

void CVCSampDlg::OnWriteWordButton() 
{
	UpdateData(true);
	unsigned long Address;
	unsigned short Value;
	sscanf(m_Address, "%lx", &Address);
	sscanf(m_ValueWrite, "%x", &Value);

   Value = Value & 0xFFFF;  //Make sure Value is 16 Bit (Word)
	OutPort(Address, Value);

	m_Status = " Write was successful";
	UpdateData(false);
}  //  end OnWriteWordButton

void CVCSampDlg::OnReadByteButton() 
{
	UpdateData(true);
	unsigned long Address;
	sscanf(m_Address, "%lx", &Address);

	unsigned short Value = InPortB(Address);

   Value = Value & 0xFF;    //Make sure Value is 8 Bit (Byte)
	m_ValueRead.Format("%.2X", Value);
	m_Status = " Read was successful";
	UpdateData(false);
}  //  end OnReadByteButton

void CVCSampDlg::OnReadWordButton() 
{
	UpdateData(true);
	unsigned long Address;
	sscanf(m_Address, "%lx", &Address);

	unsigned short Value = InPort(Address);

   Value = Value & 0xFFFF;  //Make sure Value is 16 Bit (Word)
	m_ValueRead.Format("%.4X", Value);
	m_Status = " Read was successful";
	UpdateData(false);
}

void CVCSampDlg::OnExitButton() 
{
   exit(0);	
}  //  end OnExitButton

void CVCSampDlg::OnAddressListComboChange() 
{
   CString TempString;

   UpdateData(true);
   m_AddressListCtrl.GetLBText(m_AddressIndex, TempString);
   m_Address = TempString.Right(4);
   UpdateData(false);		
}
