// IRQMDlg.cpp : implementation file
//

#include "stdafx.h"
#include "IRQMSAMP.h"
#include "IRQMDlg.h"
#include "ACCES32.h"
#include "W32IRQM.h"
#include "IRQMThrd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CIRQMThrd	*MyThreads[16];

/////////////////////////////////////////////////////////////////////////////
// CIRQMDlg dialog

CIRQMDlg::CIRQMDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CIRQMDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CIRQMDlg)
	m_BusType = _T("");
	m_Status = _T("  Enter Base, IRQ and Clear Offset, then Initialize");
	m_BaseAddress = _T("");
	m_ReadWriteRadio = 0;
	m_IRQCount = _T("  IRQ Count: 0");
	m_IRQ = 0;
	m_BusNumber = 0;
	m_ClearOffset = _T("");
	m_Offset = _T("");
	m_Value = _T("");
	m_IRQ1 = FALSE;
	m_IRQ10 = FALSE;
	m_IRQ11 = FALSE;
	m_IRQ12 = FALSE;
	m_IRQ9 = FALSE;
	m_IRQ8 = FALSE;
	m_IRQ7 = FALSE;
	m_IRQ6 = FALSE;
	m_IRQ5 = FALSE;
	m_IRQ4 = FALSE;
	m_IRQ3 = FALSE;
	m_IRQ2 = FALSE;
	m_IRQ15 = FALSE;
	m_IRQ14 = FALSE;
	m_IRQ13 = FALSE;
	m_LastIRQ = _T("  Last IRQ: 0");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CIRQMDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CIRQMDlg)
	DDX_Control(pDX, IDC_CHECK9, m_IRQCheck9);
	DDX_Control(pDX, IDC_CHECK8, m_IRQCheck8);
	DDX_Control(pDX, IDC_CHECK7, m_IRQCheck7);
	DDX_Control(pDX, IDC_CHECK6, m_IRQCheck6);
	DDX_Control(pDX, IDC_CHECK4, m_IRQCheck4);
	DDX_Control(pDX, IDC_CHECK5, m_IRQCheck5);
	DDX_Control(pDX, IDC_CHECK3, m_IRQCheck3);
	DDX_Control(pDX, IDC_CHECK2, m_IRQCheck2);
	DDX_Control(pDX, IDC_CHECK15, m_IRQCheck15);
	DDX_Control(pDX, IDC_CHECK14, m_IRQCheck14);
	DDX_Control(pDX, IDC_CHECK13, m_IRQCheck13);
	DDX_Control(pDX, IDC_CHECK12, m_IRQCheck12);
	DDX_Control(pDX, IDC_CHECK11, m_IRQCheck11);
	DDX_Control(pDX, IDC_CHECK10, m_IRQCheck10);
	DDX_Control(pDX, IDC_CHECK1, m_IRQCheck1);
	DDX_CBString(pDX, IDC_BUSTYPE, m_BusType);
	DDX_Text(pDX, IDC_STATUS, m_Status);
	DDX_Text(pDX, IDC_BASE, m_BaseAddress);
	DDX_Radio(pDX, IDC_RADIO1, m_ReadWriteRadio);
	DDX_Text(pDX, IDC_LABEL, m_IRQCount);
	DDX_Text(pDX, IDC_IRQ, m_IRQ);
	DDX_Text(pDX, IDC_BUSNUMBER, m_BusNumber);
	DDX_Text(pDX, IDC_LATCH, m_ClearOffset);
	DDX_Text(pDX, IDC_OFFSET, m_Offset);
	DDX_Text(pDX, IDC_VALUE, m_Value);
	DDX_Check(pDX, IDC_CHECK1, m_IRQ1);
	DDX_Check(pDX, IDC_CHECK10, m_IRQ10);
	DDX_Check(pDX, IDC_CHECK11, m_IRQ11);
	DDX_Check(pDX, IDC_CHECK12, m_IRQ12);
	DDX_Check(pDX, IDC_CHECK9, m_IRQ9);
	DDX_Check(pDX, IDC_CHECK8, m_IRQ8);
	DDX_Check(pDX, IDC_CHECK7, m_IRQ7);
	DDX_Check(pDX, IDC_CHECK6, m_IRQ6);
	DDX_Check(pDX, IDC_CHECK5, m_IRQ5);
	DDX_Check(pDX, IDC_CHECK4, m_IRQ4);
	DDX_Check(pDX, IDC_CHECK3, m_IRQ3);
	DDX_Check(pDX, IDC_CHECK2, m_IRQ2);
	DDX_Check(pDX, IDC_CHECK15, m_IRQ15);
	DDX_Check(pDX, IDC_CHECK14, m_IRQ14);
	DDX_Check(pDX, IDC_CHECK13, m_IRQ13);
	DDX_Text(pDX, IDC_LABEL2, m_LastIRQ);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CIRQMDlg, CDialog)
	//{{AFX_MSG_MAP(CIRQMDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_INITBUTTON, OnInitbutton)
	ON_BN_CLICKED(IDC_WRITEBUTTON, OnWritebutton)
	ON_BN_CLICKED(IDC_READBUTTON, OnReadbutton)
	ON_BN_CLICKED(IDC_EXITBUTTON, OnExitbutton)
	ON_BN_CLICKED(IDC_CHECK2, OnCheck2)
	ON_BN_CLICKED(IDC_CHECK3, OnCheck3)
	ON_BN_CLICKED(IDC_CHECK4, OnCheck4)
	ON_BN_CLICKED(IDC_CHECK5, OnCheck5)
	ON_BN_CLICKED(IDC_CHECK6, OnCheck6)
	ON_BN_CLICKED(IDC_CHECK7, OnCheck7)
	ON_BN_CLICKED(IDC_CHECK8, OnCheck8)
	ON_BN_CLICKED(IDC_CHECK9, OnCheck9)
	ON_BN_CLICKED(IDC_CHECK10, OnCheck10)
	ON_BN_CLICKED(IDC_CHECK11, OnCheck11)
	ON_BN_CLICKED(IDC_CHECK12, OnCheck12)
	ON_BN_CLICKED(IDC_CHECK13, OnCheck13)
	ON_BN_CLICKED(IDC_CHECK14, OnCheck14)
	ON_BN_CLICKED(IDC_CHECK15, OnCheck15)
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIRQMDlg message handlers

BOOL CIRQMDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

   if (InPortB(0x61) == 0xAA55) {
      MessageBox("ACCESNT.SYS not detected. Please copy ACCESNT.SYS into [NT]/system32/drivers and re-run this sample.", "Warning", MB_OK);
   }

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CIRQMDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CIRQMDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CIRQMDlg::OnInitbutton() 
{
	short BT = InterfaceTypeUndefined;
	unsigned long BaseAddress;
	unsigned short ClearOffset;

	UpdateData(true);
	if (m_BusType == "PCI")
		BT = PCIBus;
	else if (m_BusType == "ISA")
		BT = Isa;
	
	sscanf(m_BaseAddress, "%lx", &BaseAddress);
	sscanf(m_ClearOffset, "%lx", &ClearOffset);

	unsigned char Success;
	if (m_ReadWriteRadio == 0)
		Success = InitGenDriver(BaseAddress, m_IRQ, BT, m_BusNumber, ClearOffset, WRITE_TO_CLEAR);
	else
		Success = InitGenDriver(BaseAddress, m_IRQ, BT, m_BusNumber, ClearOffset, READ_TO_CLEAR);

	if (Success)
	{
		m_Status = "  Setup card using Write Port, then check the IRQ # to monitor";
		switch (m_IRQ)
		{
		case 1: m_IRQCheck1.EnableWindow(true); break;
		case 2: m_IRQCheck2.EnableWindow(true); break;
		case 3: m_IRQCheck3.EnableWindow(true); break;
		case 4: m_IRQCheck4.EnableWindow(true); break;
		case 5: m_IRQCheck5.EnableWindow(true); break;
		case 6: m_IRQCheck6.EnableWindow(true); break;
		case 7: m_IRQCheck7.EnableWindow(true); break;
		case 8: m_IRQCheck8.EnableWindow(true); break;
		case 9: m_IRQCheck9.EnableWindow(true); break;
		case 10: m_IRQCheck10.EnableWindow(true); break;
		case 11: m_IRQCheck11.EnableWindow(true); break;
		case 12: m_IRQCheck12.EnableWindow(true); break;
		case 13: m_IRQCheck13.EnableWindow(true); break;
		case 14: m_IRQCheck14.EnableWindow(true); break;
		case 15: m_IRQCheck15.EnableWindow(true); break;
		}
	}
	else
		m_Status = "  Driver Error During Initialization";

	UpdateData(false);
}

void CIRQMDlg::OnWritebutton() 
{
	unsigned long Base;
	unsigned short Offset;
	unsigned char Value;

	UpdateData(true);
	sscanf(m_BaseAddress, "%lx", &Base);
	sscanf(m_Offset, "%lx", &Offset);
	sscanf(m_Value, "%lx", &Value);
	OutPortB(Base + Offset, Value);
}

void CIRQMDlg::OnReadbutton() 
{
	unsigned long Base;
	unsigned short Offset;
	unsigned short Value;
	char text[16];

	UpdateData(true);
	sscanf(m_BaseAddress, "%lx", &Base);
	sscanf(m_Offset, "%lx", &Offset);
	Value = InPortB(Base + Offset);
	sprintf(text, "%x", Value);
	m_Value = text;
	UpdateData(false);
}

void CIRQMDlg::OnExitbutton() 
{
	exit(0);
}

void CIRQMDlg::OnCheck1() 
{
	const UCHAR TheIRQ = 1;

	if (m_IRQ1)
	{
		MyThreads[TheIRQ]->Terminate();
		AbortRequest(TheIRQ);
//		m_IRQCheck1.EnableWindow(false);
		m_Status = "Aborted - recheck the IRQ # to resume";
		m_IRQ1 = false;
		UpdateData(false);
		return;
	}
	UpdateData(true);
	MyThreads[TheIRQ] = (CIRQMThrd*)AfxBeginThread(RUNTIME_CLASS(CIRQMThrd),THREAD_PRIORITY_NORMAL,0,CREATE_SUSPENDED,NULL);
	MyThreads[TheIRQ]->InitWnd(m_hWnd, TheIRQ);
	MyThreads[TheIRQ]->ResumeThread();
}

void CIRQMDlg::OnCheck2() 
{
	const UCHAR TheIRQ = 2;

	if (m_IRQ2)
	{
		MyThreads[TheIRQ]->Terminate();
		AbortRequest(TheIRQ);
//		m_IRQCheck2.EnableWindow(false);
		m_Status = "Aborted - recheck the IRQ # to resume";
		m_IRQ2 = false;
		UpdateData(false);
		return;
	}
	UpdateData(true);
	MyThreads[TheIRQ] = (CIRQMThrd*)AfxBeginThread(RUNTIME_CLASS(CIRQMThrd),THREAD_PRIORITY_NORMAL,0,CREATE_SUSPENDED,NULL);
	MyThreads[TheIRQ]->InitWnd(m_hWnd, TheIRQ);
	MyThreads[TheIRQ]->ResumeThread();
}

void CIRQMDlg::OnCheck3() 
{
	const UCHAR TheIRQ = 3;

	if (m_IRQ3)
	{
		MyThreads[TheIRQ]->Terminate();
		AbortRequest(TheIRQ);
//		m_IRQCheck3.EnableWindow(false);
		m_Status = "Aborted - recheck the IRQ # to resume";
		m_IRQ3 = false;
		UpdateData(false);
		return;
	}
	UpdateData(true);
	MyThreads[TheIRQ] = (CIRQMThrd*)AfxBeginThread(RUNTIME_CLASS(CIRQMThrd),THREAD_PRIORITY_NORMAL,0,CREATE_SUSPENDED,NULL);
	MyThreads[TheIRQ]->InitWnd(m_hWnd, TheIRQ);
	MyThreads[TheIRQ]->ResumeThread();
}

void CIRQMDlg::OnCheck4() 
{
	const UCHAR TheIRQ = 4;

	if (m_IRQ4)
	{
		MyThreads[TheIRQ]->Terminate();
		AbortRequest(TheIRQ);
//		m_IRQCheck4.EnableWindow(false);
		m_Status = "Aborted - recheck the IRQ # to resume";
		m_IRQ4 = false;
		UpdateData(false);
		return;
	}
	UpdateData(true);
	MyThreads[TheIRQ] = (CIRQMThrd*)AfxBeginThread(RUNTIME_CLASS(CIRQMThrd),THREAD_PRIORITY_NORMAL,0,CREATE_SUSPENDED,NULL);
	MyThreads[TheIRQ]->InitWnd(m_hWnd, TheIRQ);
	MyThreads[TheIRQ]->ResumeThread();
}

void CIRQMDlg::OnCheck5() 
{
	const UCHAR TheIRQ = 5;

	if (m_IRQ5)
	{
		MyThreads[TheIRQ]->Terminate();
		AbortRequest(TheIRQ);
//		m_IRQCheck5.EnableWindow(false);
		m_Status = "Aborted - recheck the IRQ # to resume";
		m_IRQ5 = false;
		UpdateData(false);
		return;
	}
	UpdateData(true);
	MyThreads[TheIRQ] = (CIRQMThrd*)AfxBeginThread(RUNTIME_CLASS(CIRQMThrd),THREAD_PRIORITY_NORMAL,0,CREATE_SUSPENDED,NULL);
	MyThreads[TheIRQ]->InitWnd(m_hWnd, TheIRQ);
	MyThreads[TheIRQ]->ResumeThread();
}

void CIRQMDlg::OnCheck6() 
{
	const UCHAR TheIRQ = 6;

	if (m_IRQ6)
	{
		MyThreads[TheIRQ]->Terminate();
		AbortRequest(TheIRQ);
//		m_IRQCheck6.EnableWindow(false);
		m_Status = "Aborted - recheck the IRQ # to resume";
		m_IRQ6 = false;
		UpdateData(false);
		return;
	}
	UpdateData(true);
	MyThreads[TheIRQ] = (CIRQMThrd*)AfxBeginThread(RUNTIME_CLASS(CIRQMThrd),THREAD_PRIORITY_NORMAL,0,CREATE_SUSPENDED,NULL);
	MyThreads[TheIRQ]->InitWnd(m_hWnd, TheIRQ);
	MyThreads[TheIRQ]->ResumeThread();
}

void CIRQMDlg::OnCheck7() 
{
	const UCHAR TheIRQ = 7;

	if (m_IRQ7)
	{
		MyThreads[TheIRQ]->Terminate();
		AbortRequest(TheIRQ);
//		m_IRQCheck7.EnableWindow(false);
		m_Status = "Aborted - recheck the IRQ # to resume";
		m_IRQ7 = false;
		UpdateData(false);
		return;
	}
	UpdateData(true);
	MyThreads[TheIRQ] = (CIRQMThrd*)AfxBeginThread(RUNTIME_CLASS(CIRQMThrd),THREAD_PRIORITY_NORMAL,0,CREATE_SUSPENDED,NULL);
	MyThreads[TheIRQ]->InitWnd(m_hWnd, TheIRQ);
	MyThreads[TheIRQ]->ResumeThread();
}

void CIRQMDlg::OnCheck8() 
{
	const UCHAR TheIRQ = 8;

	if (m_IRQ8)
	{
		MyThreads[TheIRQ]->Terminate();
		AbortRequest(TheIRQ);
//		m_IRQCheck8.EnableWindow(false);
		m_Status = "Aborted - recheck the IRQ # to resume";
		m_IRQ8 = false;
		UpdateData(false);
		return;
	}
	UpdateData(true);
	MyThreads[TheIRQ] = (CIRQMThrd*)AfxBeginThread(RUNTIME_CLASS(CIRQMThrd),THREAD_PRIORITY_NORMAL,0,CREATE_SUSPENDED,NULL);
	MyThreads[TheIRQ]->InitWnd(m_hWnd, TheIRQ);
	MyThreads[TheIRQ]->ResumeThread();
}

void CIRQMDlg::OnCheck9() 
{
	const UCHAR TheIRQ = 9;

	if (m_IRQ9)
	{
		MyThreads[TheIRQ]->Terminate();
		AbortRequest(TheIRQ);
//		m_IRQCheck9.EnableWindow(false);
		m_Status = "Aborted - recheck the IRQ # to resume";
		m_IRQ9 = false;
		UpdateData(false);
		return;
	}
	UpdateData(true);
	MyThreads[TheIRQ] = (CIRQMThrd*)AfxBeginThread(RUNTIME_CLASS(CIRQMThrd),THREAD_PRIORITY_NORMAL,0,CREATE_SUSPENDED,NULL);
	MyThreads[TheIRQ]->InitWnd(m_hWnd, TheIRQ);
	MyThreads[TheIRQ]->ResumeThread();
}

void CIRQMDlg::OnCheck10() 
{
	const UCHAR TheIRQ = 10;

	if (m_IRQ10)
	{
		MyThreads[TheIRQ]->Terminate();
		AbortRequest(TheIRQ);
//		m_IRQCheck10.EnableWindow(false);
		m_Status = "Aborted - recheck the IRQ # to resume";
		m_IRQ10 = false;
		UpdateData(false);
		return;
	}
	UpdateData(true);
	MyThreads[TheIRQ] = (CIRQMThrd*)AfxBeginThread(RUNTIME_CLASS(CIRQMThrd),THREAD_PRIORITY_NORMAL,0,CREATE_SUSPENDED,NULL);
	MyThreads[TheIRQ]->InitWnd(m_hWnd, TheIRQ);
	MyThreads[TheIRQ]->ResumeThread();
}

void CIRQMDlg::OnCheck11() 
{
	const UCHAR TheIRQ = 11;

	if (m_IRQ11)
	{
		MyThreads[TheIRQ]->Terminate();
		AbortRequest(TheIRQ);
//		m_IRQCheck11.EnableWindow(false);
		m_Status = "Aborted - recheck the IRQ # to resume";
		m_IRQ11 = false;
		UpdateData(false);
		return;
	}
	UpdateData(true);
	MyThreads[TheIRQ] = (CIRQMThrd*)AfxBeginThread(RUNTIME_CLASS(CIRQMThrd),THREAD_PRIORITY_NORMAL,0,CREATE_SUSPENDED,NULL);
	MyThreads[TheIRQ]->InitWnd(m_hWnd, TheIRQ);
	MyThreads[TheIRQ]->ResumeThread();
}

void CIRQMDlg::OnCheck12() 
{
	const UCHAR TheIRQ = 12;

	if (m_IRQ12)
	{
		MyThreads[TheIRQ]->Terminate();
		AbortRequest(TheIRQ);
//		m_IRQCheck12.EnableWindow(false);
		m_Status = "Aborted - recheck the IRQ # to resume";
		m_IRQ12 = false;
		UpdateData(false);
		return;
	}
	UpdateData(true);
	MyThreads[TheIRQ] = (CIRQMThrd*)AfxBeginThread(RUNTIME_CLASS(CIRQMThrd),THREAD_PRIORITY_NORMAL,0,CREATE_SUSPENDED,NULL);
	MyThreads[TheIRQ]->InitWnd(m_hWnd, TheIRQ);
	MyThreads[TheIRQ]->ResumeThread();
}

void CIRQMDlg::OnCheck13() 
{
	const UCHAR TheIRQ = 13;

	if (m_IRQ13)
	{
		MyThreads[TheIRQ]->Terminate();
		AbortRequest(TheIRQ);
//		m_IRQCheck13.EnableWindow(false);
		m_Status = "Aborted - recheck the IRQ # to resume";
		m_IRQ13 = false;
		UpdateData(false);
		return;
	}
	UpdateData(true);
	MyThreads[TheIRQ] = (CIRQMThrd*)AfxBeginThread(RUNTIME_CLASS(CIRQMThrd),THREAD_PRIORITY_NORMAL,0,CREATE_SUSPENDED,NULL);
	MyThreads[TheIRQ]->InitWnd(m_hWnd, TheIRQ);
	MyThreads[TheIRQ]->ResumeThread();
}

void CIRQMDlg::OnCheck14() 
{
	const UCHAR TheIRQ = 14;

	if (m_IRQ14)
	{
		MyThreads[TheIRQ]->Terminate();
		AbortRequest(TheIRQ);
//		m_IRQCheck14.EnableWindow(false);
		m_Status = "Aborted - recheck the IRQ # to resume";
		m_IRQ14 = false;
		UpdateData(false);
		return;
	}
	UpdateData(true);
	MyThreads[TheIRQ] = (CIRQMThrd*)AfxBeginThread(RUNTIME_CLASS(CIRQMThrd),THREAD_PRIORITY_NORMAL,0,CREATE_SUSPENDED,NULL);
	MyThreads[TheIRQ]->InitWnd(m_hWnd, TheIRQ);
	MyThreads[TheIRQ]->ResumeThread();
}

void CIRQMDlg::OnCheck15() 
{
	const UCHAR TheIRQ = 15;

	if (m_IRQ15)
	{
		MyThreads[TheIRQ]->Terminate();
		AbortRequest(TheIRQ);
//		m_IRQCheck15.EnableWindow(false);
		m_Status = "Aborted - recheck the IRQ # to resume";
		m_IRQ15 = false;
		UpdateData(false);
		return;
	}
	UpdateData(true);
	MyThreads[TheIRQ] = (CIRQMThrd*)AfxBeginThread(RUNTIME_CLASS(CIRQMThrd),THREAD_PRIORITY_NORMAL,0,CREATE_SUSPENDED,NULL);
	MyThreads[TheIRQ]->InitWnd(m_hWnd, TheIRQ);
	MyThreads[TheIRQ]->ResumeThread();
}

