// DIODlg.cpp : implementation file
//

#include "stdafx.h"
#include "DIO.h"
#include "DIODlg.h"
#include "ACCES32.h"

#define MyKey   "Software\\PCIFIND\\NTioPCI\\Parameters"
#define InsCR(x) x += 0x0d; x += 0x0a;

/*
struct TPCI_COMMON_CONFIG {
	 unsigned short VendorID;
	 unsigned short DeviceID;
	 unsigned short Command;
	 unsigned short Status;
	 unsigned char RevisionID;
	 unsigned char ProgIf;
	 unsigned char SubClass;
	 unsigned char BaseClass;
	 unsigned char CacheLineSize;
	 unsigned char LatencyTimer;
	 unsigned char HeaderType;
	 unsigned char BIST;
	 unsigned long BaseAddresses[6];
	 unsigned long Reserved1[2];
	 unsigned long RomBaseAddress;
	 unsigned long Reserved2[2];
	 unsigned char InterruptLine;
	 unsigned char InterruptPin;
	 unsigned char MinimumGrant;
	 unsigned char MaximumLatency;
    };
*/

TPCI_COMMON_CONFIG buf[64];
bool RunFlag;
unsigned long Address;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDIODlg dialog

CDIODlg::CDIODlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDIODlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDIODlg)
	m_CardName = _T("");
	m_AddressSelection = _T("");
	m_InputA = _T("00000000");
	m_InputB = _T("00000000");
	m_OutputA = _T("00000000");
	m_StatusEdit = _T("This sample outputs a walking bit on Port A of the selected group. It then reads back the value from Port A.  This should be identical to the output value due to on-chip readback. It also displays the Input from Port B. If a wrap plug is installed, Port B should read the same value. Otherwise, ground individual bits on Port B to see them show zeroes on the display.");
	m_IsaEdit = _T("300");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDIODlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDIODlg)
	DDX_Control(pDX, IDC_ISA_STATIC, m_IsaStatic);
	DDX_Control(pDX, IDC_ISA_EDIT, m_IsaEditCtrl);
	DDX_Control(pDX, IDC_STATUS, m_StatusControl);
	DDX_Control(pDX, IDOK, m_TimerButton);
	DDX_Control(pDX, IDC_COMBO1, m_AddressCombo);
	DDX_Text(pDX, IDC_CARD_NAME, m_CardName);
	DDX_CBString(pDX, IDC_COMBO1, m_AddressSelection);
	DDX_Text(pDX, IDC_INPUTA, m_InputA);
	DDX_Text(pDX, IDC_INPUTB, m_InputB);
	DDX_Text(pDX, IDC_OUTPUTA, m_OutputA);
	DDX_Text(pDX, IDC_STATUS, m_StatusEdit);
	DDX_Text(pDX, IDC_ISA_EDIT, m_IsaEdit);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDIODlg, CDialog)
	//{{AFX_MSG_MAP(CDIODlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDOK, OnBeginButton)
	ON_BN_CLICKED(IDCANCEL, OnExitButton)
	ON_CBN_SELCHANGE(IDC_COMBO1, OnAddressComboChange)
	ON_WM_TIMER()
	ON_WM_SHOWWINDOW()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDIODlg message handlers

BOOL CDIODlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
   if (InPortB(0x61) == 0xAA55) {
      MessageBox("ACCESNT.SYS not detected. Please copy ACCESNT.SYS into [NT]/system32/drivers and re-run this sample.", "Warning", MB_OK);
   }

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDIODlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDIODlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDIODlg::OnExitButton() 
{
	exit(0);
}

void CDIODlg::FindCards(void)
{
	int i;
	bool found;
	HKEY Key;
	unsigned long DataType, DataLength;
	long Num;
	char AddStr[255];

	found = false;
	RegOpenKeyEx(HKEY_LOCAL_MACHINE, MyKey, 0, KEY_READ, &Key);
	DataLength = sizeof(Num);
   if (RegQueryValueEx(Key, "NumDevices", NULL, &DataType, (PUCHAR)&Num, &DataLength) != ERROR_SUCCESS)
      Num = 0;

    RunFlag = true;

	if (Num > 0)
	{
		DataLength = Num * sizeof(TPCI_COMMON_CONFIG);
		RegQueryValueEx(Key, "PCICommonConfig", NULL, &DataType, (PUCHAR)buf, &DataLength);
	}
   for (i=0; i<Num; i++) {
	   if (found)
         break;
      switch (buf[i].DeviceID) {
         case 0xECA9:
            m_CardName = "PCI-A12-16 Analog I/O Card with Digital";
            sprintf(AddStr, "Port 0: %4X", (buf[i].BaseAddresses[2] & 0xFFF8) + 0x10);
            m_AddressCombo.AddString(AddStr);
            found = true;
            break;
         case 0xECAA:
            m_CardName = "PCI-A12-16A Analog I/O Card with Digital";
            sprintf(AddStr, "Port 0: %4X", (buf[i].BaseAddresses[2] & 0xFFF8) + 0x10);
            m_AddressCombo.AddString(AddStr);
            found = true;
            break;
         case 0x2C58:
            m_CardName = "PCI-DIO-96C3 Parallel Digital I/O Card";
				sprintf(AddStr, "Port 0: %4X", buf[i].BaseAddresses[2] & 0xFFF8);
            m_AddressCombo.AddString(AddStr);
            sprintf(AddStr, "Port 1: %4X", (buf[i].BaseAddresses[2] & 0xFFF8) + 4);
            m_AddressCombo.AddString(AddStr);
				sprintf(AddStr, "Port 2: %4X", (buf[i].BaseAddresses[2] & 0xFFF8) + 8);
            m_AddressCombo.AddString(AddStr);
				sprintf(AddStr, "Port 3: %4X", (buf[i].BaseAddresses[2] & 0xFFF8) + 12);
            m_AddressCombo.AddString(AddStr);
            found = true;
            break;
           case 0x2C70:
           case 0x2C50:
              m_CardName = "PCI-DIO-96CT Parallel Digital I/O Card";
				  sprintf(AddStr, "Port 0: %4X", buf[i].BaseAddresses[2] & 0xFFF8);
              m_AddressCombo.AddString(AddStr);
              sprintf(AddStr, "Port 1: %4X", (buf[i].BaseAddresses[2] & 0xFFF8) + 4);
              m_AddressCombo.AddString(AddStr);
				  sprintf(AddStr, "Port 2: %4X", (buf[i].BaseAddresses[2] & 0xFFF8) + 8);
              m_AddressCombo.AddString(AddStr);
				  sprintf(AddStr, "Port 3: %4X", (buf[i].BaseAddresses[2] & 0xFFF8) + 12);
              m_AddressCombo.AddString(AddStr);
              found = true;
              break;
            case 0x0C50:
                m_CardName = "PCI-DIO-24H Parallel Digital I/O Card";
				    sprintf(AddStr, "Port 0: %4X", buf[i].BaseAddresses[2] & 0xFFF8);
                m_AddressCombo.AddString(AddStr);
                found = true;
                break;
            case 0x0C51:
                m_CardName = "PCI-DIO-24D Parallel Digital I/O Card";
				    sprintf(AddStr, "Port 0: %4X", buf[i].BaseAddresses[2] & 0xFFF8);
                m_AddressCombo.AddString(AddStr);
                found = true;
                break;
			case 0x0E50:
                m_CardName = "PCI-DIO-24S Parallel Digital I/O Card";
				    sprintf(AddStr, "Port 0: %4X", buf[i].BaseAddresses[2] & 0xFFF8);
                m_AddressCombo.AddString(AddStr);
                found = true;
                break;
            case 0x0E51:
                m_CardName = "PCI-DIO-24H(C) Parallel Digital I/O Card w/Counter";
				    sprintf(AddStr, "Port 0: %4X", buf[i].BaseAddresses[2] & 0xFFF8);
                m_AddressCombo.AddString(AddStr);
                found = true;
                break;
            case 0x0E52:
                m_CardName = "PCI-DIO-24D(C) Parallel Digital I/O Card w/Counter";
				    sprintf(AddStr, "Port 0: %4X", buf[i].BaseAddresses[2] & 0xFFF8);
                m_AddressCombo.AddString(AddStr);
                found = true;
                break;
            case 0x0C60:
                m_CardName = "PCI-DIO-48 Parallel Digital I/O Card";
				    sprintf(AddStr, "Port 0: %4X", buf[i].BaseAddresses[2] & 0xFFF8);
                m_AddressCombo.AddString(AddStr);
				    sprintf(AddStr, "Port 1: %4X", (buf[i].BaseAddresses[2] & 0xFFF8) + 4);
                m_AddressCombo.AddString(AddStr);
                found = true;
                break;
            case 0x0E60:
                m_CardName = "PCI-DIO-48S Parallel Digital I/O Card";
                sprintf(AddStr, "Port 0: %4X", buf[i].BaseAddresses[2] & 0xFFF8);
                m_AddressCombo.AddString(AddStr);
				    sprintf(AddStr, "Port 1: %4X", (buf[i].BaseAddresses[2] & 0xFFF8) + 4);
                m_AddressCombo.AddString(AddStr);
                found = true;
                break;
			 case 0x0C52:
				m_CardName = "PCIe-DIO-24 Parallel Digital I/O Card";
				    sprintf(AddStr, "Port 0: %4X", buf[i].BaseAddresses[2] & 0xFFF8);
                m_AddressCombo.AddString(AddStr);
				found = true;
				break;
			 case 0x0E53:
				m_CardName = "PCIe-DIO-24S Parallel Digital I/O Card";
				    sprintf(AddStr, "Port 0: %4X", buf[i].BaseAddresses[2] & 0xFFF8);
                m_AddressCombo.AddString(AddStr);
				found = true;
				break;
			 case 0x0C53:
				m_CardName = "PCIe-DIO-24D Parallel Digital I/O Card";
				    sprintf(AddStr, "Port 0: %4X", buf[i].BaseAddresses[2] & 0xFFF8);
                m_AddressCombo.AddString(AddStr);
				found = true;
				break;
			 case 0x0E55:
				m_CardName = "PCIe-DIO-24DC Parallel Digital I/O Card w/Counter";
				    sprintf(AddStr, "Port 0: %4X", buf[i].BaseAddresses[2] & 0xFFF8);
                m_AddressCombo.AddString(AddStr);
				found = true;
				break;
			 case 0x0E54:
				m_CardName = "PCIe-DIO-24DS Parallel Digital I/O Card";
				    sprintf(AddStr, "Port 0: %4X", buf[i].BaseAddresses[2] & 0xFFF8);
                m_AddressCombo.AddString(AddStr);
				found = true;
				break;
			 case 0x0E56:
				m_CardName = "PCIe-DIO-24DCS Parallel Digital I/O Card w/Counter";
				    sprintf(AddStr, "Port 0: %4X", buf[i].BaseAddresses[2] & 0xFFF8);
                m_AddressCombo.AddString(AddStr);
				found = true;
				break;
            case 0x0C61:
                m_CardName = "PCIe-DIO-48 Parallel Digital I/O Card";
				    sprintf(AddStr, "Port 0: %4X", buf[i].BaseAddresses[2] & 0xFFF8);
                m_AddressCombo.AddString(AddStr);
				    sprintf(AddStr, "Port 1: %4X", (buf[i].BaseAddresses[2] & 0xFFF8) + 4);
                m_AddressCombo.AddString(AddStr);
                found = true;
                break;
            case 0x0E61:
                m_CardName = "PCIe-DIO-48S Parallel Digital I/O Card";
                sprintf(AddStr, "Port 0: %4X", buf[i].BaseAddresses[2] & 0xFFF8);
                m_AddressCombo.AddString(AddStr);
				    sprintf(AddStr, "Port 1: %4X", (buf[i].BaseAddresses[2] & 0xFFF8) + 4);
                m_AddressCombo.AddString(AddStr);
                found = true;
                break;
            case 0x0C68:
                m_CardName = "PCI-DIO-72 Parallel Digital I/O Card";
				    sprintf(AddStr, "Port 0: %4X", buf[i].BaseAddresses[2] & 0xFFF8);
                m_AddressCombo.AddString(AddStr);
				    sprintf(AddStr, "Port 1: %4X", (buf[i].BaseAddresses[2] & 0xFFF8) + 4);
                m_AddressCombo.AddString(AddStr);
				    sprintf(AddStr, "Port 2: %4X", (buf[i].BaseAddresses[2] & 0xFFF8) + 8);
                m_AddressCombo.AddString(AddStr);
                found = true;
                break;
            case 0x0C70:
                m_CardName = "PCI-DIO-96 Parallel Digital I/O Card";
				    sprintf(AddStr, "Port 0: %4X", buf[i].BaseAddresses[2] & 0xFFF8);
                m_AddressCombo.AddString(AddStr);
				    sprintf(AddStr, "Port 1: %4X", (buf[i].BaseAddresses[2] & 0xFFF8) + 4);
                m_AddressCombo.AddString(AddStr);
				    sprintf(AddStr, "Port 2: %4X", (buf[i].BaseAddresses[2] & 0xFFF8) + 8);
                m_AddressCombo.AddString(AddStr);
				    sprintf(AddStr, "Port 3: %4X", (buf[i].BaseAddresses[2] & 0xFFF8) + 12);
                m_AddressCombo.AddString(AddStr);
                found = true;
                break;
			case 0x0C69:
                m_CardName = "P104-DIO-96 Parallel Digital I/O Card";
				    sprintf(AddStr, "Port 0: %4X", buf[i].BaseAddresses[2] & 0xFFF8);
                m_AddressCombo.AddString(AddStr);
				    sprintf(AddStr, "Port 1: %4X", (buf[i].BaseAddresses[2] & 0xFFF8) + 4);
                m_AddressCombo.AddString(AddStr);
				    sprintf(AddStr, "Port 2: %4X", (buf[i].BaseAddresses[2] & 0xFFF8) + 8);
                m_AddressCombo.AddString(AddStr);
				    sprintf(AddStr, "Port 3: %4X", (buf[i].BaseAddresses[2] & 0xFFF8) + 12);
                m_AddressCombo.AddString(AddStr);
                found = true;
                break;
            case 0x0C78:
                m_CardName = "PCI-DIO-120 Parallel Digital I/O Card";
				    sprintf(AddStr, "Port 0: %4X", buf[i].BaseAddresses[2] & 0xFFF8);
                m_AddressCombo.AddString(AddStr);
				    sprintf(AddStr, "Port 1: %4X", (buf[i].BaseAddresses[2] & 0xFFF8) + 4);
                m_AddressCombo.AddString(AddStr);
				    sprintf(AddStr, "Port 2: %4X", (buf[i].BaseAddresses[2] & 0xFFF8) + 8);
                m_AddressCombo.AddString(AddStr);
				    sprintf(AddStr, "Port 3: %4X", (buf[i].BaseAddresses[2] & 0xFFF8) + 12);
                m_AddressCombo.AddString(AddStr);
				    sprintf(AddStr, "Port 4: %4X", (buf[i].BaseAddresses[2] & 0xFFF8) + 16);
                m_AddressCombo.AddString(AddStr);
                found = true;
                break;
        }
	}
	if (!found)	{
      m_CardName = "No Card Found In Registry";

		InsCR(m_StatusEdit);
		m_StatusEdit =  "No Card Found In Registry.";
		InsCR(m_StatusEdit);
		m_StatusEdit += "This may mean the card is not installed, or NTioPCI.sys is not installed, or the card you have installed is not 8255 equipped.";
		InsCR(m_StatusEdit);
		m_StatusEdit += "Please make sure you have run PCIFind.exe for Windows 95.";
		InsCR(m_StatusEdit);
		m_StatusEdit += "If you have an ISA DIO card installed, you may continue running this sample by entering the "
			"card's Base Address in the edit box above and continuing as normal.";
		m_IsaStatic.ModifyStyle(0, WS_VISIBLE, 0);
		m_IsaEditCtrl.ModifyStyle(0, WS_VISIBLE, 0);
		m_AddressCombo.EnableWindow(false);
		m_IsaEditCtrl.SetFocus();
		m_StatusControl.LineScroll(999);

      RunFlag = false;
   }  
   
   UpdateData(false);
   m_AddressCombo.SetCurSel(0);
   if (RunFlag) {
      UpdateData(true);
	   sscanf(m_AddressSelection.Mid(8,4).GetBuffer(0), "%x", &Address);
   }
   RegCloseKey(Key);
}

void CDIODlg::OnAddressComboChange() 
{
	CString SelStr;
	UpdateData(true);
	m_AddressCombo.GetLBText(m_AddressCombo.GetCurSel(), SelStr);
	sscanf(SelStr.Mid(8,4).GetBuffer(0), "%x", &Address);

	InsCR(m_StatusEdit);
	m_StatusEdit += "New Port Selected: ";
	m_StatusEdit += SelStr;
	
	m_AddressSelection = SelStr;
	UpdateData(false);
	m_StatusControl.LineScroll(999);
}

void CDIODlg::OnBeginButton() 
{
	static bool TimerEnabled = false;

    if (!RunFlag)
		sscanf(m_IsaEdit.GetBuffer(0), "%x", &Address);

	if (TimerEnabled)
	{
		TimerEnabled = false;
		KillTimer(0);
		m_TimerButton.SetWindowText("Perform I/O");
	}
	else
	{
		TimerEnabled = true;
		OutPortB(Address + 3, 0x82);
		SetTimer(0, 1000, NULL);
		m_TimerButton.SetWindowText("Stop I/O");
	}
}

void CDIODlg::OnTimer(UINT nIDEvent) 
{
    static int value[3] = {0,0,0}, i = 0;
	int j;
	char msg[9] = "00000000";

	value[0] = 1 << i++;
	OutPortB(Address, value[0]);
	value[1] = InPortB(Address);
	value[2] = InPortB(Address+1);
	i %= 8;
	for (j=0; j<8; j++)
        msg[7-j] = (((value[0] & (1 << j)) > 0) + 0x30);
    m_OutputA = msg;
	for (j=0; j<8; j++)
        msg[7-j] = (((value[1] & (1 << j)) > 0) + 0x30);
	m_InputA = msg;
    for (j=0; j<8; j++)
        msg[7-j] = (((value[2] & (1 << j)) > 0) + 0x30);
	m_InputB = msg;

	UpdateData(false);
	
	CDialog::OnTimer(nIDEvent);
}

void CDIODlg::UpdateDriverRegistry(void)
{
    unsigned long TypeValue, StartValue, ErrorControlValue;
	HKEY Key;
	char str[255];

	RegOpenKeyEx(HKEY_LOCAL_MACHINE, MyKey, 0, KEY_ALL_ACCESS, &Key);
    
    TypeValue = 1;
	RegSetValueEx(Key, "Type", 0, REG_DWORD, (PUCHAR)&TypeValue, sizeof(TypeValue));

    StartValue = 2;
	RegSetValueEx(Key, "Start", 0, REG_DWORD, (PUCHAR)&StartValue, sizeof(StartValue));

    ErrorControlValue = 1;
	RegSetValueEx(Key, "ErrorControl", 0, REG_DWORD, (PUCHAR)&ErrorControlValue, sizeof(ErrorControlValue));

	*str = 0;
	strcat(str, "Extended Base");
	RegSetValueEx(Key, "Group", 0, REG_SZ, (PUCHAR)str, strlen(str));

	RegCloseKey(Key);
}

void CDIODlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	InsCR(m_StatusEdit);
	FindCards();
}
